#include "agent.h"



/* converts a given timeintervall into a time struct */
struct time* getHumanReadableTime(double t){
  int tag,std,min,sek;
  struct time *t_str;
  
  //printf("getHumanReadableTime:Got Time %lf\n",t);
  t_str=(struct time *) malloc(sizeof(struct time));

  t=((t/60)/60)/24;
  tag=t;
  t=t-(double)tag;
  std=t*24;
  t=(t*24)-(double)std;
  min=t*60;
  t=(t*60)-(double)min;
  sek=t*60;

  t_str->day=tag;
  t_str->hour=std;
  t_str->min=min;
  t_str->sec=sek;
  return t_str;
}


/* fetches the uptime and idletime from /proc/uptime, converts it into
   a time struct and returns them in a ut struct */ 
struct ut * readProc_uptime(){
  int fd;
  char out[40]="";
  fd=open("/proc/uptime",O_RDONLY);
  if (fd!=-1){
    int rs;
    double tot,idle;
    rs=read(fd,out,sizeof(out));
    if (rs!=-1){
      struct ut *uptime;
      uptime=(struct ut *) malloc(sizeof(struct ut));
      if (uptime==NULL){
	printf("got no memory");
	exit(-2);
      }
      sscanf(out,"%lf %lf\n",&tot,&idle);
      uptime->uptime=getHumanReadableTime(tot);
      uptime->idle=getHumanReadableTime(idle); 
      close(fd);
      return uptime;
    }else 
      perror("Fehler");
  }else
    perror("readProc:Fehler");
  return NULL;
}


/* fetches the information of /proc/sys/kernel/ostype and
   /proc/sys/kernel/osrelease and returns them as a string */
char * getSystemDescription(){
  char *out;  
  int fd;
  char tmp[50]="";

  bzero(out,AGENT_BUFFLEN);
  out=(char *) malloc(AGENT_BUFFLEN*sizeof(char));
  fd=open("/proc/sys/kernel/ostype",O_RDONLY);
  if (fd!=-1){
    int rs;
    rs=read(fd,tmp,sizeof(tmp));
    close(fd);
  }else 
    perror("Fehler");
  
  strncpy(out,tmp,strlen(tmp)-1);
  strcat(out," ");

  fd=open("/proc/sys/kernel/osrelease",O_RDONLY);
  if (fd!=-1){
    int rs;
    rs=read(fd,tmp,sizeof(tmp));
    close(fd);
  }else 
    perror("Fehler");
  strncat(out,tmp,strlen(tmp)-1);
  return out;
}


/* converts the struct time int a xsd.duration format string */ 
char * getXSDDuration(struct time *tm){
  char *out;
  out=(char *) malloc(AGENT_BUFFLEN*sizeof(char));
  bzero(out,AGENT_BUFFLEN);

  strcpy(out,"P");
  if (tm->day>0) sprintf(out,"%s%dD",out,tm->day);
  if (tm->hour|tm->min|tm->sec) strcat(out,"T");
  if (tm->hour>0) sprintf(out,"%s%dH",out,tm->hour);
  if (tm->min>0) sprintf(out,"%s%dM",out,tm->min);
  if (tm->sec>0) sprintf(out,"%s%dS",out,tm->sec);

  return out;
}
